//+-----------------------------------------------------------------------------------------------+
//|                                                        Vidya.mq4                              |
//|                                                           mladen                              |
//|                                                                                               |
//| Vidya developed by Tushar Chande                                                              |
//+-----------------------------------------------------------------------------------------------+
//| https://www.tradingview.com/script/5qkKOlVg-HIGH-and-LOW-Optimized-Trend-Tracker-HOTT-LOTT/   |
//|                                                                                               |
//|                                                                                               |
//| HIGH AND LOW Optimized Trend Tracker                                                          |
//|                                                                                               |
//| modified by Norbert Westerhuijs to function like in TradingView                               |                  
//|                                                                                               |
//|                                                                                               |
//+-----------------------------------------------------------------------------------------------+

#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property  indicator_chart_window
#property  indicator_buffers  26
#property  indicator_color16  clrDodgerBlue
#property  indicator_color10  clrSandyBrown
#property  indicator_color19  clrSandyBrown
#property  indicator_color24  clrDodgerBlue
#property  indicator_color18  clrSandyBrown
#property  indicator_color19  clrSandyBrown
#property  indicator_width16  2
#property  indicator_width10  2
#property  indicator_width11  2
#property  indicator_width24  2
#property  indicator_width18  2
#property  indicator_width19  2
#property  strict

//
//
//
//
//

enum enPriceMode
{
   mode_OPEN=0,
   mode_LOW=1,
   mode_HIGH=2,
   mode_CLOSE=3
};


enum enMaTypes
{
   ma_sma,     // Simple moving average
   ma_ema,     // Exponential moving average
   ma_smma,    // Smoothed MA
   ma_lwma,    // Linear weighted MA
   ma_slwma,   // Smoothed LWMA
   ma_dsema,   // Double Smoothed Exponential average
   ma_tema,    // Triple exponential moving average - TEMA
   ma_lsma,    // Linear regression value (lsma)
   ma_dema,     // Double exponential moving average - DEMA
   ma_vidya    // Variable Index Dynamic Moving Average
};


extern ENUM_TIMEFRAMES    TimeFrame             = PERIOD_CURRENT; // Time frame
extern enMaTypes          MaType                = ma_vidya;
extern int                MaLength              =  9;             // CMO period
extern int                VidyaSmoothPeriod     =  2;             // Smoothing period
extern enPriceMode        PriceH                = mode_HIGH;      // Price High
extern enPriceMode        PriceL                = mode_LOW;       // Price Low
extern double             Pct                   = 0.6;            // Percentage - OTT Optimization Coeff
extern int                HLPeriod              = 10;             // Highest and Lowest Period

input int                 WickWidth             = 1;                 // Candle wick width
input int                 BodyWidth             = 2;                 // If auto width = false then use this
input bool                UseAutoWidth          = true;              // Auto adjust candle body width
extern color              cndl_UP               = clrLimeGreen;
extern color              cndl_Down             = clrCrimson;
extern color              cndl_Neutralu         = clrWhite;
extern color              cndl_Neutrald         = clrWhite;
input bool                alertsOn              = false;          // Alerts on true/false?
input bool                alertsOnCurrent       = false;          // Alerts on open bar true/false?
input bool                alertsMessage         = true;           // Alerts pop-up message true/false?
input bool                alertsSound           = false;          // Alerts sound true/false?
input bool                alertsNotify          = false;          // Alerts push notification true/false?
input bool                alertsEmail           = false;          // Alerts email true/false?
input string              soundFile             = "alert2.wav";   // Sound file
extern int                btn_Subwindow         = 0;
extern ENUM_BASE_CORNER   btn_corner            = CORNER_LEFT_UPPER; 
extern string             btn_text              = "OTT candles";
extern string             btn_Font              = "Arial";
extern int                btn_FontSize          = 10;                            
extern color              btn_text_ON_color     = clrLime;
extern color              btn_text_OFF_color    = clrRed;
extern string             btn_pressed           = "OTT OFF";            
extern string             btn_unpressed         = "OTT ON";
extern color              btn_background_color  = clrDimGray;
extern color              btn_border_color      = clrBlack;
extern int                button_x              = 900;                                 
extern int                button_y              = 0;                                   
extern int                btn_Width             = 75;                                 
extern int                btn_Height            = 20;                                
extern string             soundBT               = "tick.wav";  
extern bool               Interpolate           = true;           // Interpolate in multi time frame?
//
//
bool                      show_data             = false;
string IndicatorName, IndicatorObjPrefix ,buttonId ;
//
//
double valH[],valHda[],valHdb[],slopeH[],longStopH[],shortStopH[],MTH[],HOTT[],valL[],valLda[],valLdb[],slopeL[],longStopL[],shortStopL[],MTL[],LOTT[],count[];
string indicatorFileName;
bool   returnBars;
int candlewidth=0;
double UpH[],UpH_bot[],DnH[],DnH_bot[],NuH_top[],NuH_bot[],NuH_topU[],NuH_botD[],state[];

#define _mtfCall(_buff,_ind) iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MaType,MaLength,VidyaSmoothPeriod,PriceH,PriceL,Pct,HLPeriod,WickWidth,BodyWidth,UseAutoWidth,cndl_UP,cndl_Down,cndl_Neutralu,cndl_Neutrald,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,btn_Subwindow,btn_corner,btn_text,btn_Font,btn_FontSize,btn_text_ON_color,btn_text_OFF_color,btn_pressed,btn_unpressed,btn_background_color,btn_border_color,button_x,button_y,btn_Width,btn_Height,soundBT,_buff,_ind)

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
string GenerateIndicatorName(const string target)
{
   string name = target;
   int try = 2;
   while (WindowFind(name) != -1)
   {
      name = target + " #" + IntegerToString(try++);
   }
   return name;
}
//
//
//

int init()
{
   if (UseAutoWidth)
   {
      int scale = int(ChartGetInteger(0,CHART_SCALE));
      switch(scale) 
	   {
	       case 0: candlewidth =  1; break;
	       case 1: candlewidth =  1; break;
		   case 2: candlewidth =  2; break;
		   case 3: candlewidth =  3; break;
		   case 4: candlewidth =  6; break;
		   case 5: candlewidth = 14; break;
	   }
   }
   else { candlewidth = BodyWidth; }
	
   IndicatorBuffers(26);

   SetIndexBuffer(0,UpH,INDICATOR_DATA); SetIndexLabel(0,"UpH");  
   SetIndexBuffer(1,DnH,INDICATOR_DATA); SetIndexLabel(1,"DnH");  
   SetIndexBuffer(2,NuH_top,INDICATOR_DATA); SetIndexLabel(2,"NuH_top");  
   SetIndexBuffer(3,NuH_bot,INDICATOR_DATA); SetIndexLabel(3,"NuH_bot");  
   SetIndexBuffer(4,UpH_bot,INDICATOR_DATA); SetIndexLabel(4,"UpH_bot");  
   SetIndexBuffer(5,DnH_bot,INDICATOR_DATA); SetIndexLabel(5,"DnH_bot");  
   SetIndexBuffer(6,NuH_topU,INDICATOR_DATA); SetIndexLabel(6,"NuH_topU");  
   SetIndexBuffer(7,NuH_botD,INDICATOR_DATA); SetIndexLabel(7,"NuH_botD"); 

   SetIndexBuffer(8 ,valH); SetIndexLabel(8,"Vidya High"); SetIndexStyle(8,DRAW_NONE);
   SetIndexBuffer(9 ,valHda); SetIndexLabel(9,"HOTTa"); SetIndexStyle(9,DRAW_LINE);
   SetIndexBuffer(10,valHdb); SetIndexLabel(10,"HOTTb"); 
   SetIndexBuffer(11,slopeH); SetIndexLabel(11,"dirH"); SetIndexStyle(11,DRAW_NONE);
   SetIndexBuffer(12,longStopH); SetIndexLabel(12,"LongStopH"); SetIndexStyle(12,DRAW_NONE);
   SetIndexBuffer(13,shortStopH); SetIndexLabel(13,"shortStopH"); SetIndexStyle(13,DRAW_NONE);
   SetIndexBuffer(14,MTH); SetIndexLabel(14,"MTH"); SetIndexStyle(14,DRAW_NONE);
   SetIndexBuffer(15,HOTT); SetIndexLabel(15,"HOTT");SetIndexStyle(15,DRAW_LINE);
	
   SetIndexBuffer(16,valL); SetIndexLabel(16,"Vidya Low"); SetIndexStyle(16,DRAW_NONE);
   SetIndexBuffer(17,valLda); SetIndexLabel(17,"LOTTa"); 
   SetIndexBuffer(18,valLdb); SetIndexLabel(18,"LOTTb"); 
   SetIndexBuffer(19,slopeL);	SetIndexLabel(19,"dirL"); SetIndexStyle(19,DRAW_NONE);  
   SetIndexBuffer(20,longStopL); SetIndexLabel(20,"longStopL"); SetIndexStyle(20,DRAW_NONE); 
   SetIndexBuffer(21,shortStopL); SetIndexLabel(21,"shortStopL"); SetIndexStyle(21,DRAW_NONE); 
   SetIndexBuffer(22,MTL); SetIndexLabel(22,"MTL"); SetIndexStyle(22,DRAW_NONE); 
   SetIndexBuffer(23,LOTT); SetIndexLabel(23,"LOTT");  

   SetIndexBuffer(24,state); SetIndexLabel(24,"state"); SetIndexStyle(24,DRAW_NONE); 
   SetIndexBuffer(25,count); SetIndexLabel(25,"count"); SetIndexStyle(25,DRAW_NONE); 
   
   SetIndexStyle(0,DRAW_HISTOGRAM, NULL, WickWidth,cndl_UP);
   SetIndexStyle(1,DRAW_HISTOGRAM, NULL, WickWidth,cndl_Down);
   SetIndexStyle(2,DRAW_HISTOGRAM, NULL, candlewidth,cndl_Neutralu);
   SetIndexStyle(3,DRAW_HISTOGRAM, NULL, candlewidth,cndl_Neutrald);
   SetIndexStyle(4,DRAW_HISTOGRAM, NULL, candlewidth,cndl_UP);
   SetIndexStyle(5,DRAW_HISTOGRAM, NULL, candlewidth,cndl_Down);
   SetIndexStyle(6,DRAW_HISTOGRAM, NULL, WickWidth,cndl_Neutralu);
   SetIndexStyle(7,DRAW_HISTOGRAM, NULL, WickWidth,cndl_Neutrald);
		
   indicatorFileName = WindowExpertName();
   returnBars        = (TimeFrame==-99);
   TimeFrame         = MathMax(TimeFrame,_Period);
   IndicatorShortName(timeFrameToString(TimeFrame)+" Vidya cmo");     

   IndicatorName = GenerateIndicatorName(btn_text);
   IndicatorObjPrefix = "__" + IndicatorName + "__";
   IndicatorShortName(WindowExpertName());
   IndicatorDigits(Digits);
      double val;
   if (GlobalVariableGet(IndicatorName + "_visibility", val))
   show_data = val != 0;

   ChartSetInteger(ChartID(), CHART_EVENT_MOUSE_MOVE, 1);
   buttonId = IndicatorObjPrefix+btn_text;
   createButton(buttonId, btn_text, btn_Width, btn_Height, btn_Font, btn_FontSize, btn_background_color, btn_border_color, btn_text_ON_color);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_YDISTANCE, button_y);
   ObjectSetInteger(ChartID(), buttonId, OBJPROP_XDISTANCE, button_x); 
   
   return(0);
}

//
//

void createButton(string buttonID,string buttonText,int width,int height,string font,int fontSize,color bgColor,color borderColor,color txtColor)
{
   ObjectDelete    (ChartID(),buttonID);
   ObjectCreate(ChartID(),buttonID,OBJ_BUTTON,btn_Subwindow,0,0);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_COLOR,txtColor);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_BGCOLOR,bgColor);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_BORDER_COLOR,borderColor);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_XSIZE,width);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_YSIZE,height);
   ObjectSetString (ChartID(),buttonID,OBJPROP_FONT,font);
   ObjectSetString (ChartID(),buttonID,OBJPROP_TEXT,buttonText);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_FONTSIZE,fontSize);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_SELECTABLE,0);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_CORNER,btn_corner);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_HIDDEN,1);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_XDISTANCE,9999);
   ObjectSetInteger(ChartID(),buttonID,OBJPROP_YDISTANCE,9999);
}
//
//
//

void OnDeinit(const int reason)
 {
 
   ObjectsDeleteAll(0,"OTT candles");
   ObjectsDeleteAll(ChartID(), IndicatorObjPrefix);

  }
//
//
//

bool recalc = true;
void handleButtonClicks()
{
   if (ObjectGetInteger(ChartID(), buttonId, OBJPROP_STATE))
   {
      ObjectSetInteger(ChartID(), buttonId, OBJPROP_STATE, false);
      show_data = !show_data;
      GlobalVariableSet(IndicatorName + "_visibility", show_data ? 1.0 : 0.0);
      recalc = true;
      start();
   }
}
void OnChartEvent(const int id, 
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{
   handleButtonClicks();
   if (id==CHARTEVENT_OBJECT_CLICK && ObjectGet(sparam,OBJPROP_TYPE)==OBJ_BUTTON)
   {
   if (soundBT!="") PlaySound(soundBT);     
   }
   
  
	
}
//
//
//
//

int start()
{

   handleButtonClicks();
   recalc = false;
   
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexStyle(4,DRAW_HISTOGRAM);
   SetIndexStyle(5,DRAW_HISTOGRAM);
   SetIndexStyle(6,DRAW_HISTOGRAM);
   SetIndexStyle(7,DRAW_HISTOGRAM);
   SetIndexStyle(9,DRAW_LINE);
    SetIndexStyle(15,DRAW_LINE);
    SetIndexStyle(17,DRAW_LINE);
    SetIndexStyle(18,DRAW_LINE);
     SetIndexStyle(23,DRAW_LINE);
   start2(); 
   
   if (show_data)
      {
      ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_ON_color);
      ObjectSetString(ChartID(),buttonId,OBJPROP_TEXT,btn_unpressed);
     
      }
      else
      {
      ObjectSetInteger(ChartID(),buttonId,OBJPROP_COLOR,btn_text_OFF_color);
      ObjectSetString(ChartID(),buttonId,OBJPROP_TEXT,btn_pressed);
      SetIndexStyle(0,DRAW_NONE);
      SetIndexStyle(1,DRAW_NONE);
      SetIndexStyle(2,DRAW_NONE);
      SetIndexStyle(3,DRAW_NONE);
      SetIndexStyle(4,DRAW_NONE);
      SetIndexStyle(5,DRAW_NONE);
      SetIndexStyle(6,DRAW_NONE);
      SetIndexStyle(7,DRAW_NONE);
      SetIndexStyle(9,DRAW_NONE);
      SetIndexStyle(15,DRAW_NONE);
      SetIndexStyle(17,DRAW_NONE);
      SetIndexStyle(18,DRAW_NONE);
      SetIndexStyle(23,DRAW_NONE);
         

      //template code     
      }
       return(0);
      }
//
//
//

int start2()
{
   double farkh, farkl;
   double longStopTempH, longStopTempL, shortStopTempH, shortStopTempL;
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1); count[0] = limit;
        if(ChartGetInteger(0,CHART_SCALE) != candlewidth) init();  
            if (TimeFrame != Period())
            {
               limit = (int)MathMax(limit,MathMin(Bars-1,_mtfCall(26,0)*TimeFrame/_Period));
               if (slopeH[limit]==-1) CleanPoint(limit,valHda,valHdb);
			   if (slopeL[limit]==-1) CleanPoint(limit,valLda,valLdb);
               for(int i=limit; i>=0 && !_StopFlag; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                  HOTT[i]     = _mtfCall(15,y);
                  slopeH[i]   = _mtfCall(11,y);
                  LOTT[i]     = _mtfCall(23,y);
                  slopeL[i]   = _mtfCall(19,y);
                  
                  
                  
                  
                  state[i]    = _mtfCall(24,y); 
                  
				  UpH[i]       =  EMPTY_VALUE;
                  DnH[i]       =  EMPTY_VALUE;   
                  NuH_top[i]   =  EMPTY_VALUE; 
                  NuH_bot[i]   =  EMPTY_VALUE;
                  UpH_bot[i]   =  EMPTY_VALUE;
                  DnH_bot[i]   =  EMPTY_VALUE;  
                  NuH_topU[i]  =  EMPTY_VALUE; 
                  NuH_botD[i]  =  EMPTY_VALUE;  
                       
                  if ( state[i] == 1 )   { UpH[i]  = High[i];  DnH[i]  = Low[i];UpH_bot[i] = MathMax(Open[i],Close[i]); DnH_bot[i] = MathMin(Open[i],Close[i]);}               
                  if ( state[i] == -1)   { UpH[i]  = Low[i]; DnH[i]  = High[i]; UpH_bot[i] = MathMin(Open[i],Close[i]);  DnH_bot[i] = MathMax(Open[i],Close[i]);} 
                  if ( state[i] == 2 )   { NuH_topU[i]  = High[i];  NuH_botD[i]  = Low[i]; NuH_top[i] = MathMax(Open[i],Close[i]); NuH_bot[i] = MathMin(Open[i],Close[i]); }
                //  if ( state[i] == -2)   { NuH_topU[i]  = Low[i]; NuH_botD[i]  = High[i]; NuH_top[i] = MathMin(Open[i],Close[i]); NuH_bot[i] = MathMax(Open[i],Close[i]);}
             
                  
                  if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;
                  
                 
                  //
                  //
                  //
                  
                  #define _interpolate(buff) buff[i+k] = buff[i]+(buff[i+n]-buff[i])*k/n
                  int n,k; datetime itime = iTime(NULL,TimeFrame,y);
                     for(n = 1; (i+n)<Bars && Time[i+n] >= itime; n++) continue;	
                     for(k = 1; k<n && (i+n)<Bars && (i+k)<Bars; k++) 
                     {
                        _interpolate(HOTT);
						     _interpolate(LOTT);
                     }                  
               }
               for(int i=limit; i>=0; i--)
               {
                 if (slopeH[i]==-1) PlotPoint(i,valHda,valHdb,valH); 
				 if (slopeL[i]==-1) PlotPoint(i,valLda,valLdb,valL); 
               }
               return(0);
            }            
               
   //
   //
   //
   //
   //  
   if (slopeH[limit]==-1) CleanPoint(limit,valHda,valHdb);
   if (slopeL[limit]==-1) CleanPoint(limit,valLda,valLdb);
   for(int i=limit; i>=0; i--) 
   {
    if (MaType==ma_vidya)  valH[i]        = iVidya(MathMax(iHigh(NULL,0,iHighest(NULL,0,(int)PriceH,HLPeriod,i)),iHigh(NULL,0,iHighest(NULL,0,(int)PriceL,HLPeriod,i))),MaLength,VidyaSmoothPeriod,i,0);
      else  valH[i]        = iCustomMa(MaType,MathMax(iHigh(NULL,0,iHighest(NULL,0,(int)PriceH,HLPeriod,i)),iHigh(NULL,0,iHighest(NULL,0,(int)PriceL,HLPeriod,i))),MaLength,i,Bars,0);
	  farkh          = valH[i] * Pct * 0.01;
	  longStopTempH  = valH[i] - farkh;
	  shortStopTempH = valH[i] + farkh;
	  if(i<(Bars-2))
	  {
	    if(valH[i] > longStopH[i+1] && longStopH[i+1]!= EMPTY_VALUE && longStopH[i+1]!= 0.0) 
	    {
	  	  longStopH[i] = MathMax(longStopTempH, longStopH[i+1]);
	    } else 
	    {
	  	  longStopH[i] = longStopTempH;
	    }
	    if(valH[i] < shortStopH[i+1] && shortStopH[i+1]!= EMPTY_VALUE && shortStopH[i+1]!= 0.0) 
	    {
	  	  shortStopH[i] = MathMin(shortStopTempH, shortStopH[i+1]);
	    } else 
	    {
	  	  shortStopH[i] = shortStopTempH;
	    }
	    slopeH[i] = slopeH[i+1];
	    if((slopeH[i+1] == -1) && (valH[i] > shortStopH[i+1]) && (slopeH[i+1] != EMPTY_VALUE)  && (slopeH[i+1] != 0.0))
	    {
	  	  slopeH[i] = 1;
	    } else
	    {
	  	  if((slopeH[i+1] == 1) && (valH[i] < longStopH[i+1]) && (slopeH[i+1] != EMPTY_VALUE)  && (slopeH[i+1] != 0.0))
	  	  {
	  		  slopeH[i] = -1;
	  	  } else
	  	  {
	  		  slopeH[i] = slopeH[i+1];
	  	  }
	    }
	    
	  } else
	  {
	    longStopH[i] = longStopTempH;
	    shortStopH[i] = shortStopTempH;
	    slopeH[i] = 1;	  
	  }
	  if(slopeH[i] == 1)
	  {
	    MTH[i] = longStopH[i];
	  } else
	  {
	    MTH[i] = shortStopH[i];
	  }
	  if(valH[i] > MTH[i])
	  {
	    HOTT[i] = MTH[i] * (200 + Pct) / 200;
	  }else
	  {
	    HOTT[i] = MTH[i] * (200 - Pct) / 200;
	  }

	if (MaType==ma_vidya)  valL[i] = iVidya(MathMin(iLow(NULL,0,iLowest(NULL,0,(int)PriceH,HLPeriod,i)),iLow(NULL,0,iLowest(NULL,0,(int)PriceL,HLPeriod,i))),MaLength,VidyaSmoothPeriod,i,1);
	  else valL[i] = iCustomMa(MaType,MathMin(iLow(NULL,0,iLowest(NULL,0,(int)PriceH,HLPeriod,i)),iLow(NULL,0,iLowest(NULL,0,(int)PriceL,HLPeriod,i))),MaLength,i,Bars,1);
	  farkl = valL[i] * (Pct * 0.01);
	  longStopTempL  = valL[i] - farkl;
	  shortStopTempL = valL[i] + farkl;
	  if(i<(Bars-2))
	  {
	    if(valL[i] > longStopL[i+1] && longStopL[i+1]!= EMPTY_VALUE && longStopL[i+1]!= 0.0) 
	    {
	  	  longStopL[i] = MathMax(longStopTempL, longStopL[i+1]);
	    } else 
	    {
	  	  longStopL[i] = longStopTempL;
	    }
	    if(valL[i] < shortStopL[i+1] && shortStopL[i+1]!= EMPTY_VALUE && shortStopL[i+1]!= 0.0) 
	    {
	  	  shortStopL[i] = MathMin(shortStopTempL, shortStopL[i+1]);
	    } else 
	    {
	  	  shortStopL[i] = shortStopTempL;
	    }
	    slopeL[i] = slopeL[i+1];
	    if((slopeL[i+1] == -1) && (valL[i] > shortStopL[i+1]) && (slopeL[i+1] != EMPTY_VALUE)  && (slopeL[i+1] != 0.0))
	    {
	  	  slopeL[i] = 1;
	    } else
	    {
	  	  if((slopeL[i+1] == 1) && (valL[i] < longStopL[i+1]) && (slopeL[i+1] != EMPTY_VALUE)  && (slopeL[i+1] != 0.0))
	  	  {
	  		  slopeL[i] = -1;
	  	  } else
	  	  {
	  		  slopeL[i] = slopeL[i+1];
	  	  }
	    }
	    
	  } else
	  {
	    longStopL[i] = longStopTempL;
	    shortStopL[i] = shortStopTempL;
	    slopeL[i] = 1;		  
	  }
	  if(slopeL[i] == 1)
	  {
	    MTL[i] = longStopL[i];
	  } else
	  {
	    MTL[i] = shortStopL[i];
	  }
	  if(valL[i] > MTL[i])
	  {
	    LOTT[i] = MTL[i] * (200 + Pct) / 200;
	  }else
	  {
	    LOTT[i] = MTL[i] * (200 - Pct) / 200;
	  }
	  	  
	  
      valHda[i] = EMPTY_VALUE;
      valHdb[i] = EMPTY_VALUE;
      valLda[i] = EMPTY_VALUE;
      valLdb[i] = EMPTY_VALUE;
      //slopeH[i] = (i<Bars-1) ? (valH[i]>valH[i+1]) ? 1 : (valH[i]<valH[i+1]) ? -1 : slopeH[i+1] : 0;
         if (slopeH[i]==-1) PlotPoint(i,valHda,valHdb,HOTT);      
      //slopeL[i] = (i<Bars-1) ? (valL[i]>valL[i+1]) ? 1 : (valL[i]<valL[i+1]) ? -1 : slopeL[i+1] : 0;
         if (slopeL[i]==-1) PlotPoint(i,valLda,valLdb,LOTT);  


      UpH[i]       =  EMPTY_VALUE;
      DnH[i]       =  EMPTY_VALUE;   
      NuH_top[i]   =  EMPTY_VALUE; 
      NuH_bot[i]   =  EMPTY_VALUE;
      UpH_bot[i]   =  EMPTY_VALUE;
      DnH_bot[i]   =  EMPTY_VALUE;  
      NuH_topU[i]  =  EMPTY_VALUE; 
      NuH_botD[i]  =  EMPTY_VALUE;
      
      state[i] = (i<(Bars-2) ? (Close[i]>HOTT[i]) ? 1 : (Close[i]<LOTT[i]) ? -1 : ((Close[i]>LOTT[i]) && (Close[i]<HOTT[i])) ? 2 : state[i+1] : 0);
					   
	  //if(i<(Bars-2))
	  //{
		 // if((MathMax(Close[i], Open[i])>HOTT[i]) && (MathMin(Close[i], Open[i])>HOTT[i]))
		 // {
			//  state[i] = 1;
		 // } else 
		 // {
			//  if((MathMax(Close[i], Open[i])<LOTT[i]) && (MathMin(Close[i], Open[i])<LOTT[i]))
			//  {
			//	  state[i] = -1;
			//  } else
			//  {
			//	  if(((MathMax(Close[i], Open[i])>HOTT[i]) || (MathMin(Close[i], Open[i])<LOTT[i])) && (state[i+1]==1 || state[i+1]==2))
			//	  {
			//		  state[i] = 2;
			//	  }else
			//	  {
			//		  if(((MathMax(Close[i], Open[i])>HOTT[i]) || (MathMin(Close[i], Open[i])<LOTT[i])) && (state[i+1]==-1 || state[i+1]==-2))
			//		  {
			//			  state[i] = -2;
			//		  } else
			//		  {
			//			  if((((MathMax(Close[i], Open[i])<HOTT[i]) && (MathMax(Close[i], Open[i])>LOTT[i])) || ((MathMin(Close[i], Open[i])<HOTT[i]) && (MathMin(Close[i], Open[i])>LOTT[i]))) && (state[i+1]==1 || state[i+1]==2))
			//			  {
			//				  state[i] = 2;
			//			  }else
			//			  {
			//				  if((((MathMax(Close[i], Open[i])<HOTT[i]) && (MathMax(Close[i], Open[i])>LOTT[i])) || ((MathMin(Close[i], Open[i])<HOTT[i]) && (MathMin(Close[i], Open[i])>LOTT[i]))) && (state[i+1]==-1 || state[i+1]==-2))
			//				  {
			//					  state[i] = -2;
			//				  }else
			//				  {
			//					  state[i] = state[i+1];
			//				  }
			//			  }
			//		  }
			//	  }
			//  }
		 // }  
	  //} else
	  //{
		 // state[i] = 0;
	  //}

      if ( state[i] ==  1)   { UpH[i]  = High[i];  DnH[i]  = Low[i];UpH_bot[i] = MathMax(Open[i],Close[i]); DnH_bot[i] = MathMin(Open[i],Close[i]);}               
      if ( state[i] == -1)   { UpH[i]  = Low[i]; DnH[i]  = High[i]; UpH_bot[i] = MathMin(Open[i],Close[i]);  DnH_bot[i] = MathMax(Open[i],Close[i]);} 
      if ( state[i] ==  2)   { NuH_topU[i]  = High[i];  NuH_botD[i]  = Low[i]; NuH_top[i] = MathMax(Open[i],Close[i]); NuH_bot[i] = MathMin(Open[i],Close[i]);}
     // if ( state[i] == -2)   { NuH_topU[i]  = Low[i]; NuH_botD[i]  = High[i]; NuH_top[i] = MathMin(Open[i],Close[i]); NuH_bot[i] = MathMax(Open[i],Close[i]);}
             	  

		 
   }
   
   if (alertsOn)
   {
      int whichBar = (alertsOnCurrent) ? 0 : 1;
      if (state[whichBar] != state[whichBar+1] )
      {
         if (state[whichBar] == 1) doAlert(" above range");
         if (state[whichBar] ==-1) doAlert(" below range"); 
         if (state[whichBar] == 2) doAlert(" mid-range");     
               
      }         
   }          
   
   
   return(0);
}


void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message = timeFrameToString(_Period)+" "+_Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" HL Ott "+doWhat;
             if (alertsMessage)  Alert(message);
             if (alertsNotify)   SendNotification(message);
             if (alertsEmail)    SendMail(_Symbol+" HL Ott ",message);
             if (alertsSound)    PlaySound(soundFile);
      }
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define _maInstances 2
#define _maWorkBufferx1 1*_maInstances
#define _maWorkBufferx2 2*_maInstances
#define _maWorkBufferx3 3*_maInstances

double iCustomMa(int mode, double price, double length, int r, int bars, int instanceNo=0)
{
   r = bars-r-1;
   switch (mode)
   {
      case ma_sma   : return(iSma(price,(int)MathCeil(length),r,bars,instanceNo));
      case ma_ema   : return(iEma(price,length,r,bars,instanceNo));
      case ma_smma  : return(iSmma(price,length,r,bars,instanceNo));
      case ma_lwma  : return(iLwma(price,(int)MathCeil(length),r,bars,instanceNo));
      case ma_slwma : return(iSlwma(price,(int)MathCeil(length),r,bars,instanceNo));
      case ma_dsema : return(iDsema(price,length,r,bars,instanceNo));
      case ma_tema  : return(iTema(price,length,r,bars,instanceNo));
      case ma_lsma  : return(iLinr(price,(int)MathCeil(length),r,bars,instanceNo));
      case ma_dema  : return(iDema(price,length,r,bars,instanceNo));
      default       : return(price);
   }
}

//
//
//
//
//

double workSma[][_maWorkBufferx1];
double iSma(double price, int period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workSma,0)!= _bars) ArrayResize(workSma,_bars);

   workSma[r][instanceNo+0] = price;
   double avg = price; int k=1;  for(; k<period && (r-k)>=0; k++) avg += workSma[r-k][instanceNo+0];  
   return(avg/(double)k);
}

//
//
//
//
//

double workEma[][_maWorkBufferx1];
double iEma(double price, double period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= _bars) ArrayResize(workEma,_bars);

   workEma[r][instanceNo] = price;
   if (r>0 && period>1)
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+(2.0/(1.0+period))*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}

//
//
//
//
//

double workSmma[][_maWorkBufferx1];
double iSmma(double price, double period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workSmma,0)!= _bars) ArrayResize(workSmma,_bars);

   workSmma[r][instanceNo] = price;
   if (r>1 && period>1)
          workSmma[r][instanceNo] = workSmma[r-1][instanceNo]+(price-workSmma[r-1][instanceNo])/period;
   return(workSmma[r][instanceNo]);
}

//
//
//
//
//

double workLwma[][_maWorkBufferx1];
double iLwma(double price, double period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workLwma,0)!= _bars) ArrayResize(workLwma,_bars);
   
   workLwma[r][instanceNo] = price; if (period<=1) return(price);
      double sumw = period;
      double sum  = period*price;

      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = period-k;
                sumw  += weight;
                sum   += weight*workLwma[r-k][instanceNo];  
      }             
      return(sum/sumw);
}

//
//
//
//
//


double workSlwma[][_maWorkBufferx2];
double iSlwma(double price, double period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workSlwma,0)!= _bars) ArrayResize(workSlwma,_bars); 

   //
   //
   //
   //
   //

      int SqrtPeriod = (int)MathFloor(MathSqrt(period)); instanceNo *= 2;
         workSlwma[r][instanceNo] = price;

         //
         //
         //
         //
         //
               
         double sumw = period;
         double sum  = period*price;
   
         for(int k=1; k<period && (r-k)>=0; k++)
         {
            double weight = period-k;
                   sumw  += weight;
                   sum   += weight*workSlwma[r-k][instanceNo];  
         }             
         workSlwma[r][instanceNo+1] = (sum/sumw);

         //
         //
         //
         //
         //
         
         sumw = SqrtPeriod;
         sum  = SqrtPeriod*workSlwma[r][instanceNo+1];
            for(int k=1; k<SqrtPeriod && (r-k)>=0; k++)
            {
               double weight = SqrtPeriod-k;
                      sumw += weight;
                      sum  += weight*workSlwma[r-k][instanceNo+1];  
            }
   return(sum/sumw);
}

//
//
//
//
//

double workDsema[][_maWorkBufferx2];
#define _ema1 0
#define _ema2 1

double iDsema(double price, double period, int r, int _bars, int instanceNo=0)
{
   if (ArrayRange(workDsema,0)!= _bars) ArrayResize(workDsema,_bars); instanceNo*=2;

   //
   //
   //
   //
   //
   
   workDsema[r][_ema1+instanceNo] = price;
   workDsema[r][_ema2+instanceNo] = price;
   if (r>0 && period>1)
   {
      double alpha = 2.0 /(1.0+MathSqrt(period));
          workDsema[r][_ema1+instanceNo] = workDsema[r-1][_ema1+instanceNo]+alpha*(price                         -workDsema[r-1][_ema1+instanceNo]);
          workDsema[r][_ema2+instanceNo] = workDsema[r-1][_ema2+instanceNo]+alpha*(workDsema[r][_ema1+instanceNo]-workDsema[r-1][_ema2+instanceNo]); }
   return(workDsema[r][_ema2+instanceNo]);
}

//
//
//
//
//

double workTema[][_maWorkBufferx3];
#define _tema1 0
#define _tema2 1
#define _tema3 2

double iTema(double price, double period, int r, int bars, int instanceNo=0)
{
   if (ArrayRange(workTema,0)!= bars) ArrayResize(workTema,bars); instanceNo*=3;

   //
   //
   //
   //
   //
      
   workTema[r][_tema1+instanceNo] = price;
   workTema[r][_tema2+instanceNo] = price;
   workTema[r][_tema3+instanceNo] = price;
   if (r>0 && period>1)
   {
      double alpha = 2.0 / (1.0+period);
          workTema[r][_tema1+instanceNo] = workTema[r-1][_tema1+instanceNo]+alpha*(price                         -workTema[r-1][_tema1+instanceNo]);
          workTema[r][_tema2+instanceNo] = workTema[r-1][_tema2+instanceNo]+alpha*(workTema[r][_tema1+instanceNo]-workTema[r-1][_tema2+instanceNo]);
          workTema[r][_tema3+instanceNo] = workTema[r-1][_tema3+instanceNo]+alpha*(workTema[r][_tema2+instanceNo]-workTema[r-1][_tema3+instanceNo]); }
   return(workTema[r][_tema3+instanceNo]+3.0*(workTema[r][_tema1+instanceNo]-workTema[r][_tema2+instanceNo]));
}

//
//
//
//
//

double workLinr[][_maWorkBufferx1];
double iLinr(double price, int period, int r, int bars, int instanceNo=0)
{
   if (ArrayRange(workLinr,0)!= bars) ArrayResize(workLinr,bars);

   //
   //
   //
   //
   //
   
      period = MathMax(period,1);
      workLinr[r][instanceNo] = price;
      if (r<period) return(price);
         double lwmw = period; double lwma = lwmw*price;
         double sma  = price;
         for(int k=1; k<period && (r-k)>=0; k++)
         {
            double weight = period-k;
                   lwmw  += weight;
                   lwma  += weight*workLinr[r-k][instanceNo];  
                   sma   +=        workLinr[r-k][instanceNo];
         }             
   
   return(3.0*lwma/lwmw-2.0*sma/period);
}

//
//
//
//
//

double workDema[][_maWorkBufferx2];
#define _dema1 0
#define _dema2 1

double iDema(double price, double period, int r, int bars, int instanceNo=0)
{
   if (period<=1) return(price);
   if (ArrayRange(workDema,0)!= bars) ArrayResize(workDema,bars); instanceNo*=2;

   //
   //
   //
   //
   //
      
   workDema[r][_dema1+instanceNo] = price;
   workDema[r][_dema2+instanceNo] = price;
   double alpha = 2.0 / (1.0+period);
   if (r>0)
   {
          workDema[r][_dema1+instanceNo] = workDema[r-1][_dema1+instanceNo]+alpha*(price                         -workDema[r-1][_dema1+instanceNo]);
          workDema[r][_dema2+instanceNo] = workDema[r-1][_dema2+instanceNo]+alpha*(workDema[r][_dema1+instanceNo]-workDema[r-1][_dema2+instanceNo]); }
   return(workDema[r][_dema1+instanceNo]*2.0-workDema[r][_dema2+instanceNo]);
}



#define _vidyaInstances     2
#define _vidyaInstancesSize 2
double  vidya_work[][_vidyaInstances*_vidyaInstancesSize];
#define vidya_price 0
#define vidya_value 1

double iVidya(double price, int cmoPeriods, int smoothPeriod, int r, int instanceNo=0)
{
   if (ArrayRange(vidya_work,0)!=Bars) ArrayResize(vidya_work,Bars);  int s = instanceNo*_vidyaInstancesSize;
    r = Bars-r-1;
   //
   //
   //
   //
   //
   
   vidya_work[r][s+vidya_price] = price;
          double sumUp = 0;
          double sumDo = 0;
          for (int j=0; j < cmoPeriods && (r-j-1)>=0; j++)
          {
            double diff = vidya_work[r-j][s+vidya_price]-vidya_work[r-j-1][s+vidya_price];
            if (diff > 0)
                  sumUp += diff;
            else  sumDo -= diff;
          }      
          double k = ((sumUp+sumDo)!=0) ? MathAbs((sumUp-sumDo)/(sumUp+sumDo)): 1;
   
          vidya_work[r][s+vidya_value] = (r>0) ? vidya_work[r-1][s+vidya_value]+(k*2.00/(1.00+MathMax(smoothPeriod,1)))*(vidya_work[r][s+vidya_price]-vidya_work[r-1][s+vidya_value]) : price;
   return(vidya_work[r][s+vidya_value]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
         {
            if (first[i+2] == EMPTY_VALUE) 
                  { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
            else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
         }
   else  { first[i] = from[i]; second[i] = EMPTY_VALUE; }
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}